{lsocket.pas}

{io core originally for linux bworld}

{use this code for whatever you like in programs under whater licence you like
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
}

unit lsocket;

interface
  uses sysutils,linux,sockets,inet,classes,bcrash,pgdebugout;
  type
    TSocketevent     = procedure(Sender: TObject; Error: word) of object;
    //Tdataavailevent  = procedure(data : string);
    TLasin = class
      S                  : Longint         ;  {file discriptor}
      onsessionclosed    : tsocketevent    ;
      ondataAvailable    : tsocketevent    ;
      ontimer            : procedure       ;
      connected          : boolean         ;
      nextasin           : tlasin        ;
      released           : boolean         ;
      prevasin           : tlasin        ;
      tag                : longint         ;
      receivestr         : string          ;
      procedure close;
      constructor create;
      destructor destroy; override;
      procedure release;
      procedure sendflush; virtual; // this method is a stub it doesn't do
                                    // anthing in this class it is provided for
                                    // descendents that do output as well as
                                    // input to override

    end;
    TLsocket = class(TLasin)
      //a: string;
      inAddr             : TInetSockAddr   ;
      host               : THost           ;
      sendq              : string          ;
      onsessionconnected : tsocketevent    ;


      //mainthread         : boolean         ; //for debuggin only
      addr:string;
      port:string;
      proto:string;
      procedure connect;
      procedure sendstr(str : string);
      procedure putstringinsendbuffer(newstring : string);
      procedure sendflush; override;
      //procedure messageloop;
    end;
var
  firstasin : tlasin;
  prevtime           : integer         ;
procedure messageloop;
implementation
var
  maxs: longint;
//uses bservunit;
procedure tlasin.release;
begin
  released := true;
end;
procedure tlasin.sendflush;
begin
  {this is a stub override it if you do output as well as input}
end;

constructor tlasin.create;
begin
  inherited create;
  //writeln('tlsocket.create started');
  nextasin := firstasin;
  prevasin := nil;

  if assigned(nextasin) then nextasin.prevasin := self;
  firstasin := self;
  //writeln('tlsocket.create finished');
  released := false;
end;

destructor tlasin.destroy;
begin
  //writeln('tlsocket destroyed');
  if prevasin <> nil then begin
    prevasin.nextasin := nextasin;

  end else begin
    firstasin := nextasin;
  end;
  if nextasin <> nil then begin
    nextasin.prevasin := prevasin;
  end;
  inherited destroy;
end;

procedure tlasin.close;
begin
  if connected then begin
    fcntl(s,F_SETFL,0);
    fdclose(s);
    connected := false;
    //writeln('about to call onsessionclosed from tlsocket.close');

    if assigned(onsessionclosed) then onsessionclosed(self,0);
{    if not assigned(onsessionclosed) then debugout('onsessionclosed is not assigned');}
    //writeln('called onsessionclosed from tlsocket.close');

  end;
end;

procedure tlsocket.connect;
begin
  //prevtime := 0;
  host.namelookup(addr);
  // readln(a);
  //writeln(gettimeofday);
  inAddr.family:=AF_INET;
  { port 78 in network order }
  inAddr.port:=ShortHostToNet(strtointdef(port,0));
  { localhost : 127.0.0.1 in network order }
  inAddr.addr:=HostTonet(Longint(Host.IPAddress));
  S:=Socket(AF_INET,SOCK_STREAM,0);
  if s > maxs then maxs := s;
  //writeln('about to connect');
  If Not sockets.Connect (S,inADDR,sizeof(tsockaddr)) Then begin
{    debugout ('Couldn''t connect to server');}
    //Writeln (SocketError);
    //writeln('SYS_EWOULDBLOCK=',SYS_EWOULDBLOCK);
    
    if assigned(onsessionconnected) then onsessionconnected(self,socketerror);
    fdclose(s);
    exit;
  end;
  fcntl(s,F_SETFL,OPEN_NONBLOCK);
  //writeln('fcntl complete');
  (* reset(sout,1);
  {writeln('reset complete');
  reset(sin,1);
  writeln('reset complete'); *)
  sendq := '';
  //writeln('tlsocket.connect complete');
  connected := true;
  if assigned(onsessionconnected) then onsessionconnected(self,0);
end;

procedure tlsocket.sendstr(str : string);
begin
  putstringinsendbuffer(str);
  sendflush;
end;

procedure tlsocket.putstringinsendbuffer(newstring : string);
begin
  sendq := sendq + newstring;

end;

procedure tlsocket.sendflush;
var
  lensent : integer;
begin
  //writeln(sout,line);
  //writeln('sendflush called');
  //blockwrite(sout,line[1],length(line));
  //writeln(length(sendq));
  //sendq := sendq + #13#10; // for test perposes
{  debugout('about to call send');}
  try 
    lensent := fdwrite(s,sendq[1],length(sendq));
  except
  end;
{  debugout('send complete');}
  //writeln(lensent);
  if lensent = length(sendq) then begin
    sendq := '';
  end else begin
    sendq := copy(sendq,lensent+1,length(sendq)-lensent);
  end;
  //writeln('sendflush finished');
end;

procedure messageloop;
var
  FDS        : fdset;
  numread    : integer;
  currentsocket : tlasin;
  tempsocket : tlasin;
begin
  signal(sigpipe,signalhandler(sig_ign));
  currentsocket := firstasin;
  if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed
  repeat

    if currentsocket.connected then currentsocket.sendflush;
    currentsocket := currentsocket.nextasin;
  until not assigned(currentsocket);

  try

    repeat
{      debugout('at start of outer loop');}
      fd_zero(FDS);
      currentsocket := firstasin;
      if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed

      repeat
        if currentsocket.connected then begin
          repeat
            //readln(sin,tempstring);
            //writeln(tempstring);
            setlength(currentsocket.receivestr,1024);
            //writeln('about to blockread');
            //blockread(sin,receivestr,1024,numread);
            numread := fdread(currentsocket.s,currentsocket.receivestr[1],1024);
            socketerror := linuxerror;
            //writeln(numread);
            //writeln('blockread complete');
{            debugout(inttostr(numread));}
            if numread=0 then begin
{              debugout('calling close because of numread=0');}
              currentsocket.close;
{              debugout('called close because of numread=0');}

            end;
            if (numread=-1) then begin
{              debugout('SYS_EWOULDBLOCK='+inttostr(SYS_EWOULDBLOCK));}

{              debugout('socketerror='+inttostr(socketerror));}
              numread := 0;
{              debugout(inttostr(socketerror)+' '+ inttostr(gettimeofday));}
              if (socketerror <> 0) and (socketerror <> SYS_EWOULDBLOCK) then begin
{                debugout('calling close because of a socketerror');}
                currentsocket.close;
{                debugout('called close because of a socketerror');}
              end;
            end;

            if numread > 0 then begin
              //parsecommand(false,tempstring);
              setlength(currentsocket.receivestr,numread);
              try
{                debugout('about to call ondataavailable');}

                if assigned(currentsocket.ondataavailable) then currentsocket.ondataAvailable(currentsocket,0);
{                debugout('ondataavailable complete');}

                except
                //if mainthread then begin
                assert(false,'exception raised while calling ondataAvailable ',exceptobject.classname+' '+(exceptobject as exception).message);
                //  writeln(mainthread);
                //end;
              end;
            end;
          until (numread = 0) or not (currentsocket.connected);
{          debugout('inner loop complete');}
          if (not currentsocket.released) and (currentsocket.connected) then fd_set(currentsocket.s,fds);
        end;
        tempsocket := currentsocket;
        currentsocket := currentsocket.nextasin;
        if tempsocket.released then begin
          tempsocket.free;
        end;
      until not assigned(currentsocket);
{      debugout('middle loop complete');}
      //writeln('about to wait');


      //debugout('about to call select '+inttostr(gettimeofday));
      debugout('about to call select');
      select(maxs+1,@FDS,nil,nil,1000);
      debugout('select complete');
      currentsocket := firstasin;
      if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed
      repeat
        if gettimeofday <> prevtime then begin
          if assigned(currentsocket.ontimer) then begin
            debugout('about to call ontimer');
            currentsocket.ontimer;
            debugout('ontimer complete');
          end;

          if currentsocket.connected then begin
{            debugout('about to call sendflush');}
            currentsocket.sendflush;
{            debugout('sendflush complete');}
          end;
        end;
        tempsocket := currentsocket;
        currentsocket := currentsocket.nextasin;
        if tempsocket.released then begin
          tempsocket.free;
        end;
      until not assigned(currentsocket);
      //selecttext(sin,60000);
      prevtime := gettimeofday;


    until false;
  except
    //if mainthread then begin

    assert(false,'exception raised ',exceptobject.classname+' '+(exceptobject as exception).message);
    //  writeln(mainthread);
    //end;
  end;
end;
begin
  firstasin := nil;
  maxs := 0;
  prevtime :=0;
  //writeln('lsocket.pas initialised');
end.
