(*
 *  beware ircd, Internet Relay Chat server, readtxt.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)


unit readtxt;

{
unit to read lines from text files,
accepts CR, LF, and CRLF

(delphi readln from textfile accepts only CRLF
}


interface

const
  bufsize=2048;

type
  dvar=array[0..0] of byte;
  pdvar=^dvar;

type
  Treadtext=record
    buf:pdvar;
    ofs:integer;
    f:file;
  end;

function readtext_init(var P:Treadtext;const filename:string):boolean;
function readtext_eof(var p:treadtext):boolean;
procedure readtext_close(var p:treadtext);
function readtext_line(var p:treadtext):string;

implementation


function readtext_readbuf(var p:treadtext):integer;
begin
  blockread(p.f,p.buf^[0],bufsize,result);
  if result < bufsize then fillchar(p.buf^[result],2048-result,0);
  p.ofs := 0;
end;

function readtext_byte(var p:treadtext):byte;
begin
  if p.ofs >= bufsize then readtext_readbuf(p);
  result := p.buf^[p.ofs];
  if result <> 0 then inc(p.ofs);
end;

function readtext_peek(var p:treadtext):byte;
begin
  if p.ofs >= bufsize then readtext_readbuf(p);
  result := p.buf^[p.ofs];
end;

function readtext_eof(var p:treadtext):boolean;
begin
  result := readtext_peek(p) = 0;
end;

function readtext_init(var P:Treadtext;const filename:string):boolean;
begin
  result := false;
  assignfile(p.f,filename);
  filemode := 0;
  {$i-}reset(p.f,1);{$i+}
  if ioresult <> 0 then exit;
  p.ofs := bufsize;
  getmem(p.buf,bufsize);

  result := true;
end;

procedure readtext_close(var p:treadtext);
begin
  freemem(p.buf);
  closefile(p.f);
  p.buf := nil;
end;

function readtext_line(var p:treadtext):string;
var
  a:byte;
begin
  result := '';
  repeat
    a := readtext_byte(p);
    if a = 13 then begin
      if readtext_peek(p) = 10 then readtext_byte(p);
      exit;
    end else if a = 10 then begin
      exit;
    end else result := result + chr(a);
  until a = 0;
end;

end.
